config/routes.rb
Rails.application.routes.draw do
  
  devise_for :users, path: ''

  get '/dashboard', to: "home#dashboard", :as => :dashboard


  resources :teams, :except => [:show]

  get '/play', to: "events#index", :as => :events

  get "/" => "teams#show", :constraints => { :subdomain  => /.+/ }, :as => :team_domain
  root to: "home#index"


end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/event.rb
class Event < ApplicationRecord

    extend FriendlyId
    friendly_id :name, use: :slugged

    enum division: [ :mixed, :women, :open, :men, :other ]
    enum registration: [ :individual,:team,:both ]
    enum ground: [ :grass, :beach, :indoor, :other ]
    enum level: [ :beginner, :intermediate, :elite, :other ]

end

app/models/player_profile.rb
class PlayerProfile < ApplicationRecord
    extend FriendlyId
    friendly_id :name, use: :slugged

    has_and_belongs_to_many :teams

    belongs_to :user
end

app/models/team.rb
class Team < ApplicationRecord
    extend FriendlyId
    friendly_id :name, use: :slugged

    has_and_belongs_to_many :player_profiles

    enum division: [ :mixed, :women, :open, :men, :other ]
    
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable,  and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable

  has_many :player_profiles       
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base

    def after_sign_in_path_for(resource)
        stored_location_for(resource) || dashboard_path
    end

    def default_url_options
        { host: Rails.application.config.root_host }
    end

end

app/controllers/events_controller.rb
class EventsController < ApplicationController

    def index
    
    end

end

app/controllers/home_controller.rb
class HomeController < ApplicationController

    before_action :authenticate_user!, except: [:index]

    def index

    end

    def dashboard

    end

end

app/controllers/teams_controller.rb
class TeamsController < ApplicationController

    def index
        @teams = Team.all
    end

    def show
        @team = Team.find_by_slug(request.subdomain)
    end

    def new
        @team = Team.new
    end

    def create
        @newteam = Team.new
        @newteam.name = team_params[:name]
        @newteam.location = team_params[:location]
        puts "#######"
        puts team_params[:name]
        puts team_params[:location]
        puts @newteam.inspect
        if @newteam.save!
          redirect_to teams_path
        else
          render "new"
        end
    end

    def team_params
        params.require(:team).permit(:name,:location)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper

    def team_home(team)
        root_url(subdomain: team.slug)
    end
end

app/helpers/events_helper.rb
module EventsHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/teams_helper.rb
module TeamsHelper
end

app/views/events/index.html.erb
<section class="">
  <%= render "shared/main_nav"%>
    <div class="container">
        <h1 class="title is-2">Events</h1>
    </div>
  </div>
</section>

app/views/home/dashboard.html.erb
<section class="hero is-fullheight is-default is-bold">
  <%= render "shared/main_nav"%>
  <div class="hero-body">
    <div class="container has-text-centered">
      
    </div>
  </div>
</section>

app/views/home/index.html.erb
<section class="hero is-fullheight is-default is-bold">
  <%= render "shared/main_nav"%>
  <div class="hero-body">
    <div class="container has-text-centered">
      <div class="columns is-vcentered">
        <div class="column is-5">
          <figure class="image is-square">
            <img src="<%= image_url("cover.png") %>" alt="Description">
          </figure>
        </div>
        <div class="column is-6 is-offset-1">
          <h1 class="title is-2">
            Bye Bye, Spreadsheet!
          </h1>
          <h2 class="subtitle is-4">
            Manage your ultimate life, the easy way. 
          </h2>
          <br>
          <p class="has-text-centered">
            <a href="<%= dashboard_path %>" class="button is-medium is-info is-outlined">
              Let's go
            </a>
          </p>
        </div>
      </div>
    </div>
  </div>
  <div class="hero-foot">
    <div class="container">
      <div class="tabs is-centered">
        <ul>
          <li><a>Imprint</a></li>
        </ul>
      </div>
    </div>
  </div>
</section>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Ulteamate</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/shared/_main_nav.html.erb
<div class="hero-head">
    <nav class="navbar">
        <div class="container">
            <div class="navbar-brand">
                <a class="navbar-item" href="<%= root_path %>">
                    <img src="<%= image_url("logo.png") %>" alt="Ulteamate">
                </a>
                <span class="navbar-burger burger" data-target="navbarMenu">
                    <span></span>
                    <span></span>
                    <span></span>
                </span>
            </div>
            <div id="navbarMenu" class="navbar-menu">
                <div class="navbar-end">
                    <div class="tabs is-right">
                        <ul>
                            <% if user_signed_in? %>
                                <li class=" <%= 'is-active' if current_page?(dashboard_path) %>" >
                                    <%= link_to "Dashboard", dashboard_path %>
                                </li>
                            <% end %>
                            <li class=" <%= 'is-active' if current_page?(teams_path) %>" >
                                <%= link_to "Teams", teams_path %>
                            </li>
                            <li class=" <%= 'is-active' if current_page?(events_path) %>" >
                                <%= link_to "Events", events_path %>
                            </li>
                            <% if user_signed_in? %>
                                <li>
                                    <%= link_to 'Logout', destroy_user_session_path, :method => :delete %>
                                </li>
                            <% else %>
                                <li>
                                    <%= link_to 'Login', new_user_session_path%>
                                </li>
                            <% end %>
                        </ul>
                    </div>
                </div>
            </div>
        </div>
    </nav>
</div>